Attribute VB_Name = "Results"
Dim a, wor
Const PI = 3.1415926

Public Function WriteResult(ByRef temp_ia, ByRef time_ia, ByRef temp_bit, ByRef time_bit, ByRef time_incub, _
ByRef lambda, ByRef volume_f_ferrite, ByRef diffus_bit, ByRef X_bc, ByRef X_cb, _
ByRef x_ab_bit, ByRef x_ba_bit, ByRef x_ini_bit, ByRef delta_time_bit, ByRef composition_steel() As Double, _
ByRef composition_IA() As Double, ByRef Composition() As Double, ByRef carbon_w_austenite() As Double, _
carbon_x_austenite() As Double, ByRef z() As Double, ByRef L() As Double, ByRef Area_a() As Double, _
ByRef Area_b() As Double, ByRef i_last, ByRef NucleateVolume() As Double, ByRef delta_G() As Double, _
ByRef Iron_composition() As Double, ByRef Dilute_x() As Double, ByRef TransVol() As Double, _
ByRef NucleationRate() As Double, ByRef Volume_f_austenite() As Double, ByRef Volume_f_bainite() As Double, _
ByRef C0() As Double)


    form1.StatusBar1.Panels.Item(1).Text = "Writing results to excel file"
    
'=====================================================================================
'create excel worksheet
    
    If Dir(App.Path & "\Count.dat") <> "" Then

        Open App.Path & "\Count.dat" For Input As #1

    Else
        Dim fso, MyFile
        Set fso = CreateObject("Scripting.FileSystemObject")
        Set MyFile = fso.CreateTextFile(App.Path & "\Count.dat")
        MyFile.WriteLine ("1")
        MyFile.Close
        Open App.Path & "\Count.dat" For Input As #1
    End If

    Line Input #1, strRead
    i = CInt(strRead)
    Close #1

    name1 = CStr(i)

    FileName = App.Path + "\" + name1 + ".xls"

    i = i + 1
    strWrite = CStr(i)

    Open App.Path & "\Count.dat" For Output As #1
    Print #1, strWrite    'дı
    Close #1


      
    Dim xlsApp As Object    'New Excel.Application
    Dim xlsBook As Object    'Excel.Workbook
    Dim xlsSheet As Object    'Excel.Worksheet
    
    Set xlsApp = CreateObject("Excel.Application")
    Set xlsBook = xlsApp.Workbooks.Add
    Set xlsSheet = xlsBook.Worksheets("sheet1")

    xlsApp.Visible = False
    
    
    
'==========================================================================
'write result to EXCEL sheet
    
    '---------------------------
    'initialize EXCEL sheet
    
    'input
    xlsSheet.cells(1, 5).Value = "Input Data"
    
    xlsSheet.cells(2, 1).Value = "steel composition"
    xlsSheet.cells(3, 1).Value = "C"
    xlsSheet.cells(3, 2).Value = "Mn "
    xlsSheet.cells(3, 3).Value = "Si"
    xlsSheet.cells(3, 4).Value = "Al"
    xlsSheet.cells(3, 5).Value = "P"
    xlsSheet.cells(3, 6).Value = "Nb"
    xlsSheet.cells(3, 7).Value = "Mo"
    xlsSheet.cells(3, 8).Value = "N"
    xlsSheet.cells(3, 9).Value = "S"
    xlsSheet.cells(3, 10).Value = "B"
    xlsSheet.cells(3, 11).Value = "Fe"
    For k = 1 To 11
        xlsSheet.cells(4, k).Value = composition_steel(k)
    Next k
    
    xlsSheet.cells(5, 1).Value = "IA Temperature/C"
    xlsSheet.cells(5, 2).Value = "IA Time/s"
    xlsSheet.cells(5, 3).Value = "BIT Temperature/C"
    xlsSheet.cells(5, 4).Value = "BIT Time/s"
    xlsSheet.cells(5, 5).Value = "Incubation Time/s"
    xlsSheet.cells(5, 6).Value = "Interlath spacing"
     
    xlsSheet.cells(6, 1).Value = temp_ia - 273
    xlsSheet.cells(6, 2).Value = time_ia
    xlsSheet.cells(6, 3).Value = temp_bit - 273
    xlsSheet.cells(6, 4).Value = time_bit
    xlsSheet.cells(6, 5).Value = time_incub
    xlsSheet.cells(6, 6).Value = lambda
    
    'output
    xlsSheet.cells(8, 1).Value = "Austenite composition after IA w%"
    xlsSheet.cells(9, 1).Value = "C"
    xlsSheet.cells(9, 2).Value = "Mn "
    xlsSheet.cells(9, 3).Value = "Si"
    xlsSheet.cells(9, 4).Value = "Al"
    xlsSheet.cells(9, 5).Value = "P"
    xlsSheet.cells(9, 6).Value = "Nb"
    xlsSheet.cells(9, 7).Value = "Mo"
    xlsSheet.cells(9, 8).Value = "N"
    xlsSheet.cells(9, 9).Value = "S"
    xlsSheet.cells(9, 10).Value = "B"
    xlsSheet.cells(9, 11).Value = "Fe"
    For k = 1 To 11
        xlsSheet.cells(10, k).Value = composition_IA(k)
        xlsSheet.cells(11, k).Value = Composition(k)
    Next k
    

    
    xlsSheet.cells(12, 1).Value = "Ferrite volume fraction"
    xlsSheet.cells(12, 2).Value = "Austenite volume fraction"
    xlsSheet.cells(12, 3).Value = "Bainite volume fraction"
    xlsSheet.cells(13, 1).Value = volume_f_ferrite
    xlsSheet.cells(13, 2).Value = Volume_f_austenite
    xlsSheet.cells(13, 3).Value = Volume_f_bainite
 
    xlsSheet.cells(14, 1).Value = "diffusivity /(micron^2/s)"
    xlsSheet.cells(15, 1).Value = diffus_bit
    
    xlsSheet.cells(16, 1).Value = "X_ferrite"
    xlsSheet.cells(16, 2).Value = "X_austenite"
    xlsSheet.cells(16, 3).Value = "X_ini_BIT"
    xlsSheet.cells(16, 4).Value = "X_bc"
    xlsSheet.cells(16, 5).Value = "X_cb"
    xlsSheet.cells(17, 1).Value = x_ab_bit
    xlsSheet.cells(17, 2).Value = x_ba_bit
    xlsSheet.cells(17, 3).Value = x_ini_bit
    xlsSheet.cells(17, 4).Value = X_bc
    xlsSheet.cells(17, 5).Value = X_cb
    
    xlsSheet.cells(19, 1).Value = "time /s"
    xlsSheet.cells(19, 2).Value = "Thickness/micron"
    xlsSheet.cells(19, 3).Value = "carbon w% in austenite"
    xlsSheet.cells(19, 4).Value = "Carbon mole fraction"
    xlsSheet.cells(19, 5).Value = "TransVol"     '"L /micron"
    xlsSheet.cells(19, 6).Value = "NucleationRate" '"Carbon mole fraction"
    xlsSheet.cells(19, 7).Value = "dilute"  'lambda/2-z"
    xlsSheet.cells(19, 8).Value = "V_f_austenite"
    xlsSheet.cells(19, 9).Value = "V_f_bainite"
    xlsSheet.cells(19, 10).Value = "L"  '"driving force"
    xlsSheet.cells(19, 11).Value = "A area"  '"driving force"
    xlsSheet.cells(19, 12).Value = "B area"  '"driving force"
    xlsSheet.cells(19, 13).Value = "driving force"
      
    For k = 0 To i_last - 1
        xlsSheet.cells(k + 20, 1).Value = k * delta_time_bit        'cell(k,j) k is row, j is column
        xlsSheet.cells(k + 20, 2).Value = z(k)
        xlsSheet.cells(k + 20, 3).Value = carbon_w_austenite(k)
        xlsSheet.cells(k + 20, 4).Value = carbon_x_austenite(k)
        xlsSheet.cells(k + 20, 5).Value = TransVol(k)
        xlsSheet.cells(k + 20, 6).Value = NucleationRate(k)
        xlsSheet.cells(k + 20, 7).Value = Dilute_x(k)
        xlsSheet.cells(k + 20, 8).Value = Volume_f_austenite(k)
        xlsSheet.cells(k + 20, 9).Value = Volume_f_bainite(k)
        xlsSheet.cells(k + 20, 10).Value = L(k)
        xlsSheet.cells(k + 20, 11).Value = Area_a(k)
        xlsSheet.cells(k + 20, 12).Value = Area_b(k)
     '   xlsSheet.cells(k + 20, 9).Value = NucleateVolume(k)
        xlsSheet.cells(k + 20, 13).Value = delta_G(k)
        xlsSheet.cells(k + 20, 14).Value = C0(k)
     '   xlsSheet.cells(k + 20, 11).Value = Iron_composition(k)
        
     '   xlsSheet.cells(k + 20, 4).Value = lambda / 2 - Z(k)
    Next k
    

    '-----------------------------------------------------------
    'create chart for display results
    

    'ͼ
 '   xlsSheet.Range(xlsSheet.cells(20, 1):xlsSheet.cells(K + 20, 1), xlsSheet.cells(20, 2):xlsSheet.cells(K + 20, 2)).Select
'    xlsSheet.Range("A20:A2021,C20:C2021").Select
'    xlsApp.Charts.Add

'    xlsApp.ActiveChart.ChartType = 73   'xlXYScatterLines
'    xlsApp.ActiveChart.SetSourceData Source:=xlsSheet.Range("xlsSheet.cells(20, 1):xlsSheet.cells(K + 20, 1), xlsSheet.cells(20, 2):xlsSheet.cells(K + 20, 2)"), PlotBy:=xlColumns
'    xlsApp.ActiveChart.SetSourceData Source:=xlsSheet.Range("A20:A2021,C20:C2021"), PlotBy:=xlColumns
  '  xlsapp.ActiveChart.Location Where:=xlLocationAsObject, Name:="Sheet1"
'    xlsApp.ActiveChart.HasLegend = False
 '   xlsapp.ActiveChart.HasPivotFields = False
'    xlsApp.ActiveChart.HasDataTable = False
'    xlsapp.ActiveChart.ApplyDataLabels Type:=xlDataLabelsShowValue, LegendKey:=False
      
'    With xlsApp.ActiveChart
'        .HasTitle = False
  '      .Axes(xlCategory, xlPrimary).HasTitle = False
  '      .Axes(xlValue, xlPrimary).HasTitle = False
   '     .Axes(xlCategory).MajorUnit = 0.5
 '       .ChartArea.Select
 '       .ChartArea.Copy
 '   End With
    

    '--------------------------------------
    ' save EXCEL sheet and exit it
    xlsSheet.SaveAs FileName
    xlsApp.Quit
    
    Set xlsApp = Nothing
    Set xlsBook = Nothing
    Set xlsSheet = Nothing
    Set xlsChart = Nothing
    
    form1.StatusBar1.Panels.Item(1).Text = "Displaying"
    Call Display
    
    form1.StatusBar1.Panels.Item(1).Text = "Finished"

    MsgBox ("Calculation finished")

End Function


  'PictureResultϵһλôӡַ
  Private Function PrintWord(x, y, Word As String)
     
    With form1.ptrResult
        .CurrentX = x
        .CurrentY = y
        .ForeColor = RGB(0, 0, 255)
    End With
    form1.ptrResult.Print Word
  End Function
  '廭㺯
  Private Function DrawDot(Px, Py, Color)
    form1.ptrResult.PSet (Px, Py), Color
  End Function
  Sub Coordinates()     'ֱϵ
    form1.ptrResult.DrawWidth = 1       '
    form1.ptrResult.Cls
    '趨ûϵԭPictureResult
    form1.ptrResult.Scale (-10, 10)-(10, -10)
    form1.ptrResult.Line (-10, 0)-(10, 0), RGB(0, 0, 255)
    form1.ptrResult.Line (10, 0)-(9.5, 0.5), RGB(0, 0, 255)
    form1.ptrResult.Line (10, 0)-(9.5, -0.5), RGB(0, 0, 255)
    form1.ptrResult.ForeColor = RGB(0, 0, 255)
    form1.ptrResult.Print "X"
    '   X   
    form1.ptrResult.Line (0, -10)-(0, 10), RGB(0, 0, 255)
    form1.ptrResult.Line (0, 10)-(0.25, 9.5), RGB(0, 0, 255)
    form1.ptrResult.Line (0, 10)-(-0.25, 9.5), RGB(0, 0, 255)
    form1.ptrResult.CurrentX = -0.5
    form1.ptrResult.CurrentY = 9.5
    form1.ptrResult.Print "Y"
    '   Y   
    For lin = -9 To 9
        form1.ptrResult.Line (lin, 0)-(lin, 0.5)
        wor = PrintWord(lin - 0.5, -0.5, Str(lin))
        form1.ptrResult.Line (0, lin)-(-0.25, lin)
        If lin <> 0 Then
            wor = PrintWord(-0.9, lin, Str(lin))
        End If
    Next lin
    form1.ptrResult.DrawWidth = 2
  End Sub
   
  Public Sub Display()       '
  'Forѭ㣬ʹ䰴ҹɱ仯
  'Сʹ߱ȽƽγɶЧ
    Coordinates
    For a = -2 * PI To 2 * PI Step PI / 6000
        Dot = DrawDot(a, Sin(a) * 5, RGB(0, 255, 0))
    Next a
    wor = PrintWord(3, -6, "   y=Sinx")
  End Sub

   

